export type Callback = (newSearchParams: string) => void;
export declare abstract class UrlStateRouter {
    push(href: string): void;
    subscribe(fn: Callback): void;
    unsubscribe(fn: Callback): void;
}
export type GenericRouterOptions = {
    poolingIntervalMs?: number;
};
export declare class GenericRouter extends UrlStateRouter {
    private options;
    private interval;
    constructor(options: GenericRouterOptions);
    push(href: string): void;
    subscribe(fn: Callback): void;
    unsubscribe(fn: Callback): void;
    onSearchParamsChange(): void;
    private startPolling;
    private stopPolling;
}
export declare function getGenericRouter(): GenericRouter;
